Angry birds does not work (test failures in js/src/jit-test/tests/jaeger/testSetTypedFloatArray.js with gcc4.7)

Bug #1003733 reported by Chris Coulson on 2012-05-24
8
This bug affects 1 person
Affects Status Importance Assigned to Milestone
gcc
Fix Released
Medium
gcc-4.7 (Ubuntu)
Medium
Unassigned
Quantal
Medium
Unassigned

Bug Description

I noticed this earlier when running the peacekeeper tests, that the canvas does not display any content on the build of Firefox we have in quantal. This also happens at http://chrome.angrybirds.com/ (although, there are occasional flickers of corruption on mouseover).

- This is broken on all builds I've tried with gcc4.7 (and is not dependant on PGO)
- It works when building the same version of Firefox with gcc4.6
- It is still broken even with accelerated layers disabled (layers.acceleration.disabled=true)
- It affects both 2d and webgl

ProblemType: Bug
DistroRelease: Ubuntu 12.10
Package: firefox 13.0~b4+build1-0ubuntu4 [modified: usr/share/apport/package-hooks/source_firefox.py]
ProcVersionSignature: Ubuntu 3.4.0-3.7-generic 3.4.0
Uname: Linux 3.4.0-3-generic x86_64
AddonCompatCheckDisabled: False
AlsaVersion: Advanced Linux Sound Architecture Driver Version 1.0.25.
ApportVersion: 2.1-0ubuntu1
Architecture: amd64
ArecordDevices:
 **** List of CAPTURE Hardware Devices ****
 card 0: Intel [HDA Intel], device 0: STAC92xx Analog [STAC92xx Analog]
   Subdevices: 1/1
   Subdevice #0: subdevice #0
AudioDevicesInUse:
 USER PID ACCESS COMMAND
 /dev/snd/controlC0: chr1s 5728 F.... pulseaudio
 /dev/snd/pcmC0D0p: chr1s 5728 F...m pulseaudio
BuildID: 20120522181908
Card0.Amixer.info:
 Card hw:0 'Intel'/'HDA Intel at 0xf6960000 irq 44'
   Mixer name : 'Intel IbexPeak HDMI'
   Components : 'HDA:111d76d5,1028040a,00100104 HDA:80862804,80860101,00100000'
   Controls : 32
   Simple ctrls : 13
Channel: beta
Date: Thu May 24 01:42:00 2012
ForcedLayersAccel: False
IfupdownConfig:
 auto lo
 iface lo inet loopback
InstallationMedia: Ubuntu 11.10 "Oneiric Ocelot" - Beta amd64 (20110901)
IpRoute:
 default via 192.168.0.1 dev wlan0 proto static
 169.254.0.0/16 dev wlan0 scope link metric 1000
 192.168.0.0/24 dev wlan0 proto kernel scope link src 192.168.0.3 metric 2
 192.168.122.0/24 dev virbr0 proto kernel scope link src 192.168.122.1
MostRecentCrashID: bp-e0f08dbe-05e2-45a4-b1dc-7be982120206
Profiles: Profile0 (Default) - LastVersion=13.0/20120522181908 (In use)
RelatedPackageVersions:
 rhythmbox-mozilla 2.96-0ubuntu7
 totem-mozilla 3.0.1-0ubuntu22
 adobe-flashplugin 11.2.202.235-0precise1
 gnome-shell 3.4.1-0ubuntu2
 icedtea-6-plugin 1.2-2ubuntu1
RunningIncompatibleAddons: False
SourcePackage: firefox
UpgradeStatus: Upgraded to quantal on 2011-11-16 (189 days ago)
dmi.bios.date: 02/15/2011
dmi.bios.vendor: Dell Inc.
dmi.bios.version: A07
dmi.board.name: 04373Y
dmi.board.vendor: Dell Inc.
dmi.board.version: A03
dmi.chassis.type: 9
dmi.chassis.vendor: Dell Inc.
dmi.modalias: dmi:bvnDellInc.:bvrA07:bd02/15/2011:svnDellInc.:pnLatitudeE6410:pvr0001:rvnDellInc.:rn04373Y:rvrA03:cvnDellInc.:ct9:cvr:
dmi.product.name: Latitude E6410
dmi.product.version: 0001
dmi.sys.vendor: Dell Inc.

Chris Coulson (chrisccoulson) wrote :
Changed in firefox (Ubuntu Quantal):
importance: Undecided → Critical
status: New → Triaged
Changed in firefox (Ubuntu Quantal):
assignee: nobody → Chris Coulson (chrisccoulson)
summary: - Canvas does not work when built with gcc4.7
+ Angry birds does not work (HTML canvas is broken when built with gcc4.7)

Ok, this is actually because of https://bugzilla.mozilla.org/show_bug.cgi?id=754554. Turning methodjit off for content makes the issues go away.

summary: - Angry birds does not work (HTML canvas is broken when built with gcc4.7)
+ Angry birds does not work (test failures in testSetTypedFloatArray)
summary: - Angry birds does not work (test failures in testSetTypedFloatArray)
+ Angry birds does not work (test failures in js/src/jit-
+ test/tests/jaeger/testSetTypedFloatArray.js)
summary: Angry birds does not work (test failures in js/src/jit-
- test/tests/jaeger/testSetTypedFloatArray.js)
+ test/tests/jaeger/testSetTypedFloatArray.js with gcc4.7)
Chris Coulson (chrisccoulson) wrote :

I've switched this back to using gcc4.6 for now

Changed in firefox (Ubuntu Quantal):
assignee: Chris Coulson (chrisccoulson) → nobody
importance: Critical → Medium
In , Rguenth (rguenth) wrote :

The following is miscompiled at -O3.

extern void abort (void);

struct Foo
{
  char a : 1;
  char b : 7;
};

struct Foo x[256];
int y[256];

void __attribute__((noinline,noclone)) bar (int n)
{
  int i;
  for (i = 0; i < n; ++i)
    {
      x[i].a = 0;
      y[i] = 3;
    }
}

int main()
{
  x[5].b = 7;
  bar (256);
  if (x[5].b != 7)
    abort ();
  return 0;
}

In , Rguenth (rguenth) wrote :

4.5 works.

In , Rguenth (rguenth) wrote :

Author: rguenth
Date: Tue May 29 14:40:16 2012
New Revision: 187961

URL: http://gcc.gnu.org/viewcvs?root=gcc&view=rev&rev=187961
Log:
2012-05-29 Richard Guenther <email address hidden>

 PR tree-optimization/53516
 * tree-data-ref.c (stmt_with_adjacent_zero_store_dr_p): Reject
 bitfield accesses.
 * tree-vect-data-refs.c (vect_analyze_data_refs): Likewise.

 * gcc.dg/torture/pr53516.c: New testcase.

Added:
    trunk/gcc/testsuite/gcc.dg/torture/pr53516.c
Modified:
    trunk/gcc/ChangeLog
    trunk/gcc/testsuite/ChangeLog
    trunk/gcc/tree-data-ref.c
    trunk/gcc/tree-vect-data-refs.c

In , Rguenth (rguenth) wrote :

Author: rguenth
Date: Tue May 29 14:44:08 2012
New Revision: 187964

URL: http://gcc.gnu.org/viewcvs?root=gcc&view=rev&rev=187964
Log:
2012-05-29 Richard Guenther <email address hidden>

 PR tree-optimization/53516
 * tree-data-ref.c (stmt_with_adjacent_zero_store_dr_p): Reject
 bitfield accesses.
 * tree-vect-data-refs.c (vect_analyze_data_refs): Likewise.

 * gcc.dg/torture/pr53516.c: New testcase.

Added:
    branches/gcc-4_7-branch/gcc/testsuite/gcc.dg/torture/pr53516.c
Modified:
    branches/gcc-4_7-branch/gcc/ChangeLog
    branches/gcc-4_7-branch/gcc/testsuite/ChangeLog
    branches/gcc-4_7-branch/gcc/tree-data-ref.c
    branches/gcc-4_7-branch/gcc/tree-vect-data-refs.c

In , Rguenth (rguenth) wrote :

Fixed on the trunk and the 4.7 branch for now.

affects: firefox (Ubuntu Quantal) → gcc-4.7 (Ubuntu Quantal)
Chris Coulson (chrisccoulson) wrote :

The fix is in quantal now

Changed in gcc-4.7 (Ubuntu Quantal):
status: Triaged → Fix Released
Changed in gcc:
importance: Unknown → Medium
status: Unknown → In Progress
Changed in gcc:
status: In Progress → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.